#include <stdio.h>
#include <stdlib.h>
#include <memory.h>
#include <time.h>
#include<algorithm>
#include<vector>
using namespace std;

__int64 ncmp=0;

extern "C" int icmp(const void *a,const void *b){
	ncmp++;
	int A=*(const int *)a;
	int B=*(const int *)b;
	return A<B ? -1 : A>B ? 1 : 0;
}

#define iGT(a,b) (icmp(a,b)>0)
//#define iGT(a,b) (*(a)>*(b))

inline void iswap(int *a,int *b){
	int u=*a; *a=*b; *b=u;
}
void sort(int *a,int b){
	while(b>1){
		int k=0;
		for(int i=1;i<b;i++) if(iGT(a+k,a+i)) k=i;
		iswap(a,a+k);
		a++; b--;
	}
}
void aswap(int *arr1,int *arr2,int l){ 
	while(l--) iswap(arr1++,arr2++);
}
// arr1(-l1..0] :merge: arr2(-l2..0] -> arr2(-l2..l1]
int backmerge(int *arr1,int l1,int *arr2,int l2){
	int *arr0=arr2+l1;
	for(;;){
		if(iGT(arr1,arr2)){ 
			iswap(arr1--,arr0--); 
			if(--l1==0) return 0;
		}else{ 
			iswap(arr2--,arr0--); 
			if(--l2==0) break;
		}
	}
	int res=l1; 
	do iswap(arr1--,arr0--); while(--l1);
	return res;
}
// merge arr[p0..p1) by buffer arr[p1..p1+r)
void rmerge(int *arr,int l,int r){
	for(int i=0;i<l;i+=r){
		// select smallest arr[p0+n*r]
		int q=i;
		for(int j=i+r;j<l;j+=r){
			if(iGT(arr+q,arr+j)) q=j;
		}		
		if(q!=i) aswap(arr+i,arr+q,r); // swap it with current position
		if(i!=0){
			aswap(arr+l,arr+i,r);  // swap current position with buffer
			backmerge(arr+(l+r-1),r,arr+(i-1),r); // buffer :merge: arr[i-r..i) -> arr[i-r..i+r)
		}
	}
}
int rbnd(int len){
	len=len/2;
	int k=0;
	for(int i=1;i<len;i*=2) k++;
	len/=k;
	for(k=1;k<=len;k*=2) ;
	return k;
}

void msort(int *arr,int len){
	if(len<12){ sort(arr,len); return; }
	int r=rbnd(len);
	int lr=(len/r-1)*r;
	for(int p=2;p<=lr;p+=2){
		if(iGT(arr+(p-2),arr+(p-1))) iswap(arr+(p-2),arr+(p-1));
		if(p&2) continue;
		aswap(arr+(p-2),arr+p,2);
		int m=len-p;
		int q=2;
		for(;;){
			int q0=2*q;
			if(q0>m || (p&q0)) break;
			backmerge(arr+(p-q-1),q,arr+(p+q-1),q);
			q=q0;
		}
		backmerge(arr+(p+q-1),q,arr+(p-q-1),q);
		int q1=q;
		q*=2;
		while((q&p)==0){
			q*=2;
			rmerge(arr+(p-q),q,q1);
		}
	}
	int q1=0;
	for(int q=r;q<lr;q*=2) if((lr&q)!=0){
		q1+=q;
		if(q1!=q) rmerge(arr+(lr-q1),q1,r);
	}
	int s=len-lr;
	msort(arr+lr,s);
	aswap(arr,arr+lr,s);
	s+=backmerge(arr+(s-1),s,arr+(lr-1),lr-s);
	msort(arr,s);
}

//#include "tqsort.hpp"

int A[100000000];
bool myfunction (int i,int j) { ncmp++; return (i<j); }

void main(){
	for(int k=14;k>=0;k--){
	ncmp=0;
	int N=99999847>>k;
	printf("N=%d\n",N);
	A[0]=12345;
	for(int i=1;i<N;i++) A[i]=(A[i-1]*199973+1);
	long t1=clock();
	msort(A,N);
	long t2=clock();
	bool q=true;
	for(int i=1;i<N;i++) if(A[i]<A[i-1]) q=false;
	printf("result: %s, ncmp=%I64d, time=%ld\n",q ? "Ok" : "Fail",ncmp,t2-t1);

	ncmp=0;
	A[0]=12345;
	for(int i=1;i<N;i++) A[i]=(A[i-1]*199973+1);
	t1=clock();

	//qsort(A,N,sizeof(int),icmp);
	
	vector<int> myvector (A, A+N);
	for(int i=0;i<N;i++) myvector[i]=A[i];
	sort (myvector.begin(), myvector.end(), myfunction); 	
	
	//QuickI(A,N);
	t2=clock();

	q=true;
	for(int i=1;i<N;i++) if(myvector[i]<myvector[i-1]) q=false;
	printf("qsort: %s, ncmp=%I64d, time=%ld\n",q ? "Ok" : "Fail",ncmp,t2-t1);
	}
}